*------------------------------------------------------------------------------*
* Procedure Name .. ZOOMBOX()
* Parameters ...... Top, Left, Bottom and Right of Box, and Box Characters
* Assumes ......... Current Color
* Returns ......... Null
* Notes ........... Explodes a Box on Screen
*                   
*------------------------------------------------------------------------------*
FUNCTION zoombox
PARAMETERS top,left,bottom,right, zoomc

*-- Initialize Variables
ztop    = top+INT((bottom-top)/2)
zleft   = left+INT((right-left)/2)
zbottom = bottom-INT((bottom-top)/2)
zright  = right-INT((right-left)/2)

*-- Varify Zoom and Zoom Character Variables.  If wrong type, load with default
zoom    = IF(TYPE('zoomval')<>'N',2,zoomval)        && See note at end of program
zoomc   = IF(TYPE('zoom')<>'C','ͻȺ ',zoomc)
zoomch  = IF(LEN(zoomc) < 9,'         ',REPLICATE(SUBSTR(zoomc,9,1),9))

*-- Test for Zoom = 0.  If 0, do not zoom, but display box
IF zoom = 0
  @ top,left,bottom,right BOX zoomc
  RETURN ''
ENDIF

*-- Adjust for Horizontal/Vertical Size Differential
zoomv   = bottom - top
zoomh   = right - left
zoomv   = IF(zoomh > zoomv,zoom*(zoomv/zoomh),zoom)
zoomh   = IF(zoomv > zoomh,zoom*(zoomh/zoomv),zoom)

*-- Do the Zoom Loop
DO WHILE .T.
  @ ztop,zleft,zbottom,zright BOX zoomch
  ztop    = IF(ztop-zoomv < top,top,ztop-zoomv)
  zbottom = IF(zbottom+zoomv > bottom,bottom,zbottom+zoomv)
  zleft   = IF(zleft-zoomh < left,left,zleft-zoomh)
  zright  = IF(zright+zoomh >right,right,zright+zoomh)
  IF ztop=top .AND. zbottom=bottom .AND. zleft=left .AND. zright=right
    EXIT
  ENDIF
ENDDO

*-- Draw Final Box
  @ top,left,bottom,right BOX zoomc

*-- Return to Calling Program
RETURN ''

*-- Function Notes
&& The variable "zoomval" may be defined as a constant during program 
&& initialization.  In this way the zoom speed may be changed depending on
&& the speed of the target system.  I have incorporated the capability to
&& pass a parameter from DOS in the form of /Zn where 'n' is a value from
&& 0 to 9, which is loaded into the 'zoomval' variable at program init.  
&& Additionally, for those not desiring window zoom, (it looks nice, but
&& uses a little overhead, for those "power-users"), a value of 0 disables
&& the zoom function.
